Subject: Re: [PATCH] RCU: don't turn off lockdep when find suspicious rcu_dereference_check() usage

From: "Paul E. McKenney" <[email-masked]>
Date: Tue, 27 Apr 2010 16:31:11 -0700

On Tue, Apr 27, 2010 at 01:58:30PM -0400, Miles Lane wrote:
> On Tue, Apr 27, 2010 at 12:22 PM, Paul E. McKenney
> <[email-masked]> wrote:
> > On Mon, Apr 26, 2010 at 09:27:44PM -0700, Paul E. McKenney wrote:
> >> On Mon, Apr 26, 2010 at 11:35:10AM -0700, Eric W. Biederman wrote:
> >> > "Paul E. McKenney" <[email-masked]> writes:
> >> >
> >> > > Eric Dumazet traced these down to a commit from Eric Biederman.
> >> > >
> >> > > If I don't hear from Eric Biederman in a few days, I will attempt a
> >> > > patch, but it would be more likely to be correct coming from someone
> >> > > with a better understanding of the code.  ;-)
> >> >
> >> > I already replied.
> >> >
> >> > http://lkml.org/lkml/2010/4/21/420
> >>
> >> You did indeed!!!  This experience is giving me an even better appreciation
> >> of the maintainers' ability to keep all their patches straight!
> >>
> >> I will put together something based on your suggestion.
> >
> > How about the following?
> >
> >                                                        Thanx, Paul
> >
> > ------------------------------------------------------------------------
> >
> > commit 85fa42bd568ab99c375f018761ae6345249942cd
> > Author: Paul E. McKenney <[email-masked]>
> > Date:   Mon Apr 26 21:40:05 2010 -0700
> >
> >    net: suppress RCU lockdep false positive in twsk_net()
> >
> >    Calls to twsk_net() are in some cases protected by reference counting
> >    as an alternative to RCU protection.  Cases covered by reference counts
> >    include __inet_twsk_kill(), inet_twsk_free(), inet_twdr_do_twkill_work(),
> >    inet_twdr_twcal_tick(), and tcp_timewait_state_process().  RCU is used
> >    by inet_twsk_purge().  Locking is used by established_get_first()
> >    and established_get_next().  Finally, __inet_twsk_hashdance() is an
> >    initialization case.
> >
> >    It appears to be non-trivial to locate the appropriate locks and
> >    reference counts from within twsk_net(), so used rcu_dereference_raw().
> >
> >    Signed-off-by: Paul E. McKenney <[email-masked]>
> >
> > diff --git a/include/net/inet_timewait_sock.h b/include/net/inet_timewait_sock.h
> > index 79f67ea..a066fdd 100644
> > --- a/include/net/inet_timewait_sock.h
> > +++ b/include/net/inet_timewait_sock.h
> > @@ -224,7 +224,9 @@ static inline
> >  struct net *twsk_net(const struct inet_timewait_sock *twsk)
> >  {
> >  #ifdef CONFIG_NET_NS
> > -       return rcu_dereference(twsk->tw_net);
> > +       return rcu_dereference_raw(twsk->tw_net); /* protected by locking, */
> > +                                                 /* reference counting, */
> > +                                                 /* initialization, or RCU. */
> >  #else
> >        return &init_net;
> >  #endif
> >
> 
> Worked for me.  Thanks!

Thank you both!  I have added Eric's Acked-by and Miles's Tested-by.

							Thanx, Paul